#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2400three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 2400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2400three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three24004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three24004xi = {
                1:'0x2329y-577z',
                2:'100x88y-2396z',
                3:'1076x1663y-1354z',
                4:'1076x2113y-365z',
                5:'1088x1963y-847z',
                6:'1092x1820y-1118z',
                7:'113x237y-2385z',
                8:'1169x1615y-1334z',
                9:'1187x2057y-341z',
                10:'1192x1770y-1097z',
                11:'1194x1911y-825z',
                12:'122x2332y-553z',
                13:'124x98y-2394z',
                14:'1261x1562y-1314z',
                15:'1290x1714y-1075z',
                16:'1295x1995y-317z',
                17:'1297x1852y-802z',
                18:'133x645y-2307z',
                19:'1349x1504y-1294z',
                20:'137x251y-2382z',
                21:'1384x1652y-1054z',
                22:'1397x1788y-780z',
                23:'139x2009y-1304z',
                24:'1400x1927y-293z',
                25:'1435x1440y-1273z',
                26:'1476x1585y-1032z',
                27:'148x105y-2393z',
                28:'1494x1718y-757z',
                29:'1500x1853y-270z',
                30:'1518x1371y-1253z',
                31:'1564x1512y-1010z',
                32:'1587x1643y-734z',
                33:'1597x1774y-246z',
                34:'1598x1298y-1233z',
                35:'15x118y-2397z',
                36:'163x264y-2379z',
                37:'1649x1435y-989z',
                38:'1673x1220y-1212z',
                39:'1676x1563y-711z',
                40:'1689x1689y-222z',
                41:'172x659y-2301z',
                42:'1730x1353y-967z',
                43:'1761x1477y-688z',
                44:'1777x1600y-198z',
                45:'1806x1266y-945z',
                46:'1841x1387y-665z',
                47:'1860x1506y-174z',
                48:'189x2162y-1024z',
                49:'190x1841y-1526z',
                50:'190x275y-2376z',
                51:'1917x1293y-642z',
                52:'1937x1407y-150z',
                53:'213x671y-2294z',
                54:'218x283y-2373z',
                55:'22x30y-2399z',
                56:'244x2327y-530z',
                57:'246x2012y-1284z',
                58:'248x289y-2369z',
                59:'256x680y-2287z',
                60:'26x140y-2395z',
                61:'279x293y-2365z',
                62:'27x588y-2326z',
                63:'289x1844y-1508z',
                64:'2x71y-2398z',
                65:'301x687y-2279z',
                66:'303x2159y-1002z',
                67:'312x294y-2361z',
                68:'33x2000y-1324z',
                69:'345x293y-2356z',
                70:'347x690y-2272z',
                71:'353x2009y-1264z',
                72:'366x2316y-506z',
                73:'378x288y-2352z',
                74:'388x1841y-1489z',
                75:'393x691y-2264z',
                76:'39x162y-2394z',
                77:'39x48y-2399z',
                78:'412x281y-2347z',
                79:'417x2150y-980z',
                80:'441x688y-2256z',
                81:'460x2000y-1243z',
                82:'487x1832y-1470z',
                83:'488x2299y-483z',
                84:'490x683y-2247z',
                85:'532x2134y-958z',
                86:'539x674y-2239z',
                87:'54x183y-2392z',
                88:'568x1985y-1223z',
                89:'587x1818y-1451z',
                90:'588x661y-2230z',
                91:'58x63y-2398z',
                92:'609x2275y-459z',
                93:'60x609y-2320z',
                94:'638x645y-2221z',
                95:'646x2113y-936z',
                96:'675x1964y-1202z',
                97:'687x1798y-1432z',
                98:'687x626y-2212z',
                99:'729x2244y-436z',
                100:'72x202y-2390z',
                101:'736x603y-2203z',
                102:'758x2085y-914z',
                103:'75x2158y-1046z',
                104:'781x1937y-1181z',
                105:'784x577y-2193z',
                106:'786x1773y-1413z',
                107:'78x77y-2397z',
                108:'7x11y-2399z',
                109:'7x95y-2398z',
                110:'832x547y-2183z',
                111:'847x2207y-412z',
                112:'870x2050y-892z',
                113:'884x1742y-1393z',
                114:'886x1904y-1160z',
                115:'92x220y-2388z',
                116:'95x628y-2314z',
                117:'963x2163y-389z',
                118:'97x1910y-1609z',
                119:'980x2010y-870z',
                120:'981x1705y-1374z',
                121:'990x1865y-1139z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2400three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire2400three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2400THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2400THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2400THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE2400THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2400THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three24004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2400THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2400THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2400THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three24004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three24004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2400THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2400THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2400THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2400three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                